function AnimatedSprite(img, w, h) {
	
	this.image = img;
	this.width = w;
	this.height = h;
	
	this.x = 0;
	this.y = 0;
	this.visible = true;
	
	this.animations = [];
	this.totalAnimations = 0;
	this.currentAnimation = 0;
	
	this.currentFrame = 0;
	
	this.interval = 1;
	this.wait = this.interval;
}

AnimatedSprite.prototype = {

	addAnimation : function(anim) {
		
		this.animations[this.totalAnimations] = anim;
		this.totalAnimations++;
	},
	
	setAnimation : function(anim) {
		
		var i = this.totalAnimations;
		
		while (i-- > 0) {
		
			if (this.animations[i].name == anim) {
				
				this.currentAnimation = i;
				break;
			}
		}
	},
	
	update : function() {
		
		if (this.wait-- <= 0) {
			
			var anim = this.animations[this.currentAnimation];
			this.currentFrame++;
			
			if (this.currentFrame >= anim.totalFrames) {
				
				this.currentFrame = 0;
			}
			
			this.wait = this.interval;
		}
	},
	
	draw : function() {
		
			var anim = this.animations[this.currentAnimation];
			
			var px = anim.frames[this.currentFrame].x;
			var py = anim.frames[this.currentFrame].y;
			
			context2D.drawImage(this.image, px, py, this.width, this.height, this.x * scale, this.y * scale, this.width * scale, this.height * scale); 
	}
}