var Game = function(players) {
	
	this.numPlayers = players;
	
	this.isRunning = true;
	this.isStarted = false;
	
	this.TOTAL_ROCKS = 6;
	this.SPIN = 8;
	this.SPEED = 4;
	this.SCALE = 0.1;

	this.rockDeviation = 200;
	this.rockSpeed = 2;
	this.rockSpawnInterval = 100;
	this.rockSpawnCount = 0;
	
	this.rocks = [];
	this.score = 0;
	
	this.players = [];
	
	while (this.players.length < this.numPlayers) {
		
		this.players.push(new Player(this.players.length + 1));
	}
	
	this.hud = new HUD(this.numPlayers);
	/*
	this.test1 = new ParticleSystem();
	this.test2 = new ParticleSystem();
	
	this.test = [this.test1, this.test2];
	*/
	this.stars1 = new ParticleSystem();
	this.stars2 = new ParticleSystem();
	/*
	this.testAnim = new AnimatedSprite(images["assets/coin.png"], 28, 28);
	this.testAnim.x = 100;
	this.testAnim.y = 100;
	
	var anim = new Animation("test");
	var i = 0;
	while (i++ < 20) {
		
		anim.addFrame(i * 28, 0);
	}
	this.testAnim.addAnimation(anim);
	*/
	
	target = this;
}

Game.prototype = {
	
	init : function() {
		
		this.isStarted = false;
		
		this.score = 0;
		this.hud.setScore(this.score);
		
		this.rockSpeed = 3;
		
		this.players[0].x = Constants.WIDTH / 2;
		this.players[0].y = (Constants.HEIGHT / 2);
		
		this.players[0].isAlive = true;
		this.players[0].isPressed = false;
		this.players[0].rotation = 0;
		this.players[0].setScale(1);
		this.players[0].dir.vector(this.players[0].rotation);
		
		this.players[0].lastDir.x = this.players[0].dir.x;
		this.players[0].lastDir.y = this.players[0].dir.y;
		
		var rockOffset = 0;
		
		if (this.numPlayers == 2) {
			
			this.players[0].x = (Constants.WIDTH / 2) - 35;
			
			this.players[1].x = (Constants.WIDTH / 2) + 35;
			this.players[1].y = (Constants.HEIGHT / 2);
			
			this.players[1].isAlive = true;
			this.players[1].isPressed = false;
			this.players[1].rotation = 0;
			this.players[1].setScale(1);
			this.players[1].dir.vector(this.players[1].rotation);
			
			this.players[1].lastDir.x = this.players[1].dir.x;
			this.players[1].lastDir.y = this.players[1].dir.y;
		
			rockOffset = 35;
		}
		
		this.resetRocks();
		
		this.positionRock(this.rocks[0], (Constants.WIDTH / 2) + (Math.random() * this.rockDeviation) - (this.rockDeviation / 2), this.players[0].y + (Constants.HEIGHT / 3), 1.5);
		this.positionRock(this.rocks[1], this.players[0].x + rockOffset, this.players[0].y, 2);
		this.positionRock(this.rocks[2], this.players[0].x + rockOffset, this.players[0].y - (Constants.HEIGHT / 3), 1.75);
		/*
		this.test1.init(images["assets/frog_eye.png"], 30, 30, 0, 0);
		this.test1.setScaling(0.92);
		this.test1.setLifeRandomness(2);
		//this.test.setSpeedRandomness(1, 1);
		this.test1.setSpawnArea(25, 25);
		
		this.test2.init(images["assets/frog_eye.png"], 30, 30, 0, 0);
		this.test2.setScaling(0.92);
		this.test2.setLifeRandomness(2);
		//this.test.setSpeedRandomness(1, 1);
		this.test2.setSpawnArea(25, 25);
		*/
		this.stars1.init(images["assets/star1.png"], 10, 360, 0, 2);
		this.stars1.setSpawnInterval(36);
		this.stars1.x = 240;
		this.stars1.setSpawnArea(Constants.WIDTH, 0);
		this.stars1.setFrameOffset(360);
		this.stars1.start();
		this.stars1.pause();
		
		this.stars2.init(images["assets/star2.png"], 10, 720, 0, 1);
		this.stars2.setSpawnInterval(72);
		this.stars2.x = 240;
		this.stars2.setSpawnArea(Constants.WIDTH, 0);
		this.stars2.setFrameOffset(720);
		this.stars2.start();
		this.stars2.pause();
	},
	
	initRocks : function() {
		
		var i = this.TOTAL_ROCKS;
		
		while (i-- > 0) {
			
			var rock = new Rock();
			this.rocks.push(rock);
		}
	},
	
	resetRocks : function() {
		
		var i = this.rocks.length;
		
		while (i-- > 0) {
			
			this.rocks[i].visible = false;
			this.rocks[i].y = 0;
		}
	},
	
	positionRock : function(rock, px, py, sc) {
		
		rock.visible = true;
		
		rock.x = px;
		rock.y = py;
		
		rock.setScale(sc);
	},
	
	spawnRock : function(rock) {
		
		var px = 240 + (Math.random() * this.rockDeviation) - (this.rockDeviation / 2);
		var py = -200 + (Math.random() * -100);
		var sc = 1.5 + Math.random();
		
		this.positionRock(rock, px, py, sc);
	},
	
	updateRocks : function() {
		
		var i = this.rocks.length;
		
		if (this.isStarted) {
				
			if (this.rockSpawnCount-- < 0) {
				
				// spawn rock
				while (i-- > 0) {
					
					if (!this.rocks[i].visible) {
						
						this.spawnRock(this.rocks[i]);
						break;
					}
				}
				
				this.rockSpawnCount = this.rockSpawnInterval;
			}
			
			this.rockSpeed += 0.001;
		}
		
		i = this.rocks.length;
		
		while (i-- > 0) {
			
			if (this.rocks[i].visible) {
			
				if (this.isStarted) this.rocks[i].y += this.rockSpeed;
				
				if (this.rocks[i].y > Constants.HEIGHT + this.rocks[i].radius) {
					
					this.rocks[i].y = 0;
					this.rocks[i].visible = false;
				}
			}
			
			this.rocks[i].draw();
		}
	},
	
	pausePressed : function() {
	
		if (this.isRunning) this.pause();
		else this.resume();
	},
	
	pause : function() {
	
		//this.hud.pause();
		this.isRunning = false;
	},
	
	resume : function() {
	
		//this.hud.resume();
		this.isRunning = true;
	},
	
	click : function(mx, my) {
		
		
	},
	
	draw : function() {
		
		
	},
	
	onKeyDown : function(key) {
		
		if (key == 1) {
			
			this.onMouseDown();
		}
	},
	
	onKeyUp : function(key) {
		
		if (key == 1) {
			
			this.onMouseUp();
		}
	},
	
	onMouseDown : function(player) {
		
		if (this.isRunning) {
			
			// check buttons first
			if (this.hud.buttonPause.isOver) {
				
				return;
			}
			
			var p = 0;
			if (this.numPlayers > 1) p = player - 1;
			
			if (this.players[p].isAlive) {
			
				this.players[p].isPressed = true;
				
				//this.test[p].setSpeed(-this.players[p].lastDir.x * 4, -this.players[p].lastDir.y * 4);
				//this.test[p].start();
				
				if (!this.isStarted) {
				
					this.isStarted = true;
					
					this.stars1.resume();
					this.stars2.resume();
				}
			}
			
			if (p == 0) this.hud.showHelp1 = false;
			else this.hud.showHelp2 = false;
		}
	},
	
	onMouseUp : function(player) {
		
		if (this.isRunning) {
			
			// check buttons first
			if (this.hud.buttonPause.isOver) {
				
				this.hud.click(mousePosition.x, mousePosition.y);
				return;
			}
			
			var p = 0;
			if (this.numPlayers > 1) p = player - 1;
			
			if (this.players[p].isAlive) {
				
				if (this.players[p].isPressed) {
					
					var i = this.TOTAL_ROCKS;
					var isLanded = false;
					
					while (i-- > 0) {
					
						if (this.rocks[i].visible) {							
							
							if (Collisions.circle(this.players[p].x, this.players[p].y, 20, this.rocks[i].x, this.rocks[i].y, this.rocks[i].radius)) {
								
								isLanded = true;
								break;
							}
						}
					}
					
					// death!
					if (!isLanded) {
						
						this.players[p].isAlive = false;
						this.playerLost(p);
					}
					
					this.players[p].lastDir.x = this.players[p].dir.x;
					this.players[p].lastDir.y = this.players[p].dir.y;
				}
			}
			
			this.players[p].isPressed = false;
		}
	},
	
	playerLost : function(p) {
		
		var winner = p - 1;
		if (winner < 0) winner = 1;
		
		this.hud.addWin(winner);
	},
	
	drawText : function(text, x, y, font, colour) {
		
		context2D.font = font || "200% Arial";
		context2D.fillStyle = colour || "#FFFFFF";
		
		context2D.fillText(text, x * scale, y * scale);
	},
	
	update : function(mx, my) {
		
		this.hud.update(mx, my);
		
		//if (this.isRunning) {
			
			this.stars2.update();
			this.stars2.draw();
			
			this.stars1.update();
			this.stars1.draw();
			
			this.updateRocks();
			
			var i = this.numPlayers;
			
			while (i-- > 0) {
				
				if (this.players[i].isAlive) {
					
					if (this.players[i].isPressed) {
						
						this.players[i].x += this.players[i].lastDir.x * this.SPEED;
						this.players[i].y += this.players[i].lastDir.y * this.SPEED;
						
						this.players[i].rotation += this.SPIN;
						this.players[i].dir.vector(this.players[i].rotation);
						
						if (this.players[i].scale < 1.25) {
							
							this.players[i].scale += this.SCALE;
							this.players[i].setScale(this.players[i].scale);
						}
						else {
							
							this.players[i].scale = 1.25;
							this.players[i].setScale(this.players[i].scale);
						}
					}
					else {
						
						if (this.players[i].scale > 1) {
							
							this.players[i].scale -= this.SCALE;
							this.players[i].setScale(this.players[i].scale);
						}
						else {
							
							this.players[i].scale = 1;
							this.players[i].setScale(this.players[i].scale);
						}
						
						if (this.isStarted) this.players[i].y += this.rockSpeed;
					}
					
					if (this.players[i].y > Constants.HEIGHT + 30 || this.players[i].y < -30 || this.players[i].x > Constants.WIDTH + 30 || this.players[i].x < -30) {
						
						// death
						this.players[i].isAlive = false;
						this.playerLost(i);
					}					
				}
				else {
					
					if (this.players[i].scale > 0) {
					
						this.players[i].scale -= this.SCALE;
						this.players[i].setScale(this.players[i].scale);
					}
					else {
						
						if (this.numPlayers > 1) firstPlay2 = false;
						else firstPlay1 = false;
						
						this.init();
					}
				}
				/*
				this.test[i].x = (this.players[i].x);// - (this.players[i].lastDir.x * 25);
				this.test[i].y = (this.players[i].y);// - (this.players[i].lastDir.y * 25);
				this.test[i].update();
				this.test[i].draw();
				*/
			}
			
			if (this.isStarted) {
			
				this.score += 10;
				this.hud.setScore(this.score);
			}
			
			i = this.numPlayers;
			while (i-- > 0) {
				
				var p = this.players[i];
				p.draw();
			}
			
			if (this.score > hiscore) hiscore = this.score;
			
			this.hud.draw();
			
			//this.testAnim.update();
			//this.testAnim.draw();
		//}
	},
	
	cleanUp : function() {
		
		
	}
}