var HUD = function(players) {
	
	this.numPlayers = players;
	this.score = 0;
	
	this.wins = [0, 0];
	
	// pause menu
	this.isPaused = false;
	this.buttonPause = new BasicButton(Constants.WIDTH - 42, 10, images["assets/pause_out.png"], images["assets/pause_over.png"]);
	
	// help stuff
	this.divide = images["assets/dividing_line.png"];
	
	if (isTouch) {
		
		this.help = images["assets/help_tap.png"];
		this.p1Help = images["assets/p1_help_tap.png"];
		this.p2Help = images["assets/p2_help_tap.png"];
	}
	else {
		
		this.help = images["assets/help_key.png"];
		this.p1Help = images["assets/p1_help_key.png"];
		this.p2Help = images["assets/p2_help_key.png"];
	}
	
	this.showHelp1 = true;
	this.showHelp2 = true;
	
	if (players == 1 && !firstPlay1) this.showHelp1 = false;
	if (players == 2 && !firstPlay2) this.showHelp2 = false;
	
	target = this;
}

HUD.prototype = {
	
	init : function() {
		
		
	},
	
	setScore : function(val) {
		
		this.score = val;
	},
	
	addWin : function(player) {
		
		this.wins[player]++;
	},
	
	click : function(mx, my) {
		
		if (this.buttonPause.click(mx, my)) {
			
			game.isRunning = false;
			quitGame();
		}
	},
	
	draw : function() {
		
		if (this.showHelp1) {
			
			if (this.numPlayers == 1) {
				
				// single player help
				context2D.drawImage(this.help, ((Constants.WIDTH * 0.5) - (this.help.width * 0.5)) * scale, 600 * scale, this.help.width * scale, this.help.height * scale);
			}
			else {
				
				// p1 help
				context2D.drawImage(this.p1Help, 10 * scale, 600 * scale, this.p1Help.width * scale, this.p1Help.height * scale);
			}
		}
		
		if (this.showHelp2 && this.numPlayers > 1) {
			
			// p2 help
			context2D.drawImage(this.p2Help, (Constants.WIDTH - this.p2Help.width - 10) * scale, 600 * scale, this.p2Help.width * scale, this.p2Help.height * scale);
		}
		
		if (this.numPlayers > 1) {
			
			if (isTouch) {
			
				if (this.showHelp1 || this.showHelp2) {
					
					// divider
					context2D.drawImage(this.divide, 238 * scale, 0, this.divide.width * scale, this.divide.height * scale);
				}
			}
			
			printText(80, 16, "" + this.wins[0], true);
			printText(Constants.WIDTH - 80, 16, "" + this.wins[1], true);
		}
		
		this.buttonPause.draw();
		
		printText(240, 48, "" + this.score, true);
	},
	
	update : function(mx, my) {
		
		this.buttonPause.update(mx, my);
	}
}