var Transition = function() {
	
	this.visible = false;
	
	this.imageTop = images["assets/transition_1.png"];
	this.imageBottom = images["assets/transition_2.png"];
	
	// start at the bottom
	this.position = Constants.HEIGHT;
	
	this.isTop = true;
	this.speed = 60;
	
	target = this;
}

Transition.prototype = {
	
	start : function() {
		
		this.isTop = true;
		
		this.position = Constants.HEIGHT;
		this.visible = true;
	},
	
	onComplete : function() {
		
		this.visible = false;
		//this.start();
	},
	
	onHidden : function() {
		
		transFunc();
	},
	
	draw : function() {
		
		if (this.visible) {
		
			if (this.isTop) context2D.drawImage(this.imageTop, 0, this.position * scale, this.imageTop.width * scale, this.imageTop.height * scale);
			else context2D.drawImage(this.imageBottom, 0, (this.position + Constants.HEIGHT + this.imageTop.height) * scale, this.imageTop.width * scale, this.imageBottom.height * scale);
			
			// clear between
			var px = 0;
			var py = 0;
			if (this.position + this.imageTop.height > 0) py = (this.position + this.imageTop.height) * scale;
			
			context2D.clearRect(px, py, canvas.width, (this.position + Constants.HEIGHT + this.imageTop.height) * scale);
		}
	},
	
	update : function() {
		
		if (this.visible) {
			
			this.position -= this.speed;
			
			if (this.position <= -this.imageTop.height && this.isTop) {
				
				this.onHidden();
				this.isTop = false;
			}
			else if (this.position <= (Constants.HEIGHT + this.imageBottom.height  + this.imageTop.height) * -1) {
				
				this.onComplete();
			}
		}
	},
	
	cleanUp : function() {
		
		this.imageTop = null;
		this.imageBottom = null;
	}
}