var Vector2D = function(x, y) {
	
	this.x = x || 0;
	this.y = y || 0;
};

Vector2D.prototype = {
	
	magnitude : function() {
		
		return Math.sqrt((this.x * this.x) + (this.y * this.y));
	},
	
	normalise : function() {
		
		var m = this.magnitude();
		
		this.x = this.x / m;
		this.y = this.y / m;

		return this;	
	},

	dot : function(v) {
		
		return (this.x * v.x) + (this.y * v.y) ;
	},
	
	angle : function(useRadians) {
		
		return Math.atan2(this.y,this.x) * (useRadians ? 1 : Vector2DConst.TO_DEGREES);
		
	},
	
	vector : function(ang) {
		
		this.x = Math.sin(ang * Vector2DConst.TO_RADIANS);
		this.y = -Math.cos(ang * Vector2DConst.TO_RADIANS);
	}
};

Vector2DConst = {
	
	TO_DEGREES : 180 / Math.PI,
	TO_RADIANS : Math.PI / 180
};